#!/usr/bin/python
# -*- coding: latin1 -*-
# -----------------------------------------------------------------------------
# Tux Droid - Tux Gadget - Threads
# Copyright (C) 2007 C2ME Sa <remi.jocaille@c2me.be>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
# -----------------------------------------------------------------------------
# $Id: $
# -----------------------------------------------------------------------------
import threading

class GdgThreads(object):

    def __init__(self):
        self.__my_threads = []

    def start_new_thread(self, function, argss = None):
        if argss == None:
            t = threading.Thread(target = function)
        else:
            t = threading.Thread(target = function, args = argss)
        t.setName(str(function))
        t.start()
        self.__my_threads.append(t)

    def join(self):
        print threading.enumerate()
        for t in self.__my_threads:
            if t.isAlive():
                #print t.getName()
                try:
                    t._Thread__stop()
                except:
                    pass
                t.join()
                
gadget_thread = GdgThreads()
